﻿using blog.danielvistisen.com.Validation.Core.Attributes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace blog.danielvistisen.com.Validation.Core.Common
{
    public static class Validator
    {
        public static List<string> ValidateAllProperties(object instance)
        {
            List<string> result = new List<string>();
            foreach (PropertyInfo property in ReflectionHelper.GetPropertyInfos(instance))
            {
                var errorString = ValidateMethod(instance, property);
                if (!string.IsNullOrEmpty(errorString))
                {
                    result.Add(errorString);
                }
            }

            return result;
        }

        public static string ValidateProperty(object instance, string propertyName)
        {
            var property = ReflectionHelper.GetPropertyInfo(instance, propertyName);

            return ValidateMethod(instance, property);
        }

        private static string ValidateMethod(object instance, PropertyInfo property)
        {
            var vma = ReflectionHelper.GetAttribute<ValidateMethodAttribute>(property);

            if (vma != null)
            {
                return ReflectionHelper.InvokeMethod<string>(instance, vma.MethodName);
            }
            else
            {
                return string.Empty;
            }
        }
    }
}
