﻿using blog.danielvistisen.com.Validation.Core.Attributes;
using blog.danielvistisen.com.Validation.Core.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace blog.danielvistisen.com.Validation.Core.ViewModels
{
    public class PersonViewModel : ViewModelBase
    {
        private string firstName;
        private string lastName;

        [ValidateMethod("ValidateFirstName")]
        public string FirstName
        {
            get { return firstName; }
            set { SetProperty(ref firstName, value); }
        }

        [ValidateMethod("ValidateLastName")]
        public string LastName
        {
            get { return lastName; }
            set { SetProperty(ref lastName, value); }
        }

        public string ValidateFirstName()
        {
            if (string.IsNullOrEmpty(FirstName))
            {
                return "First name is mandatory";
            }

            return string.Empty;
        }

        public string ValidateLastName()
        {
            if (string.IsNullOrEmpty(LastName))
            {
                return "Last name is mandatory";
            }

            return string.Empty;
        }
    }
}
